﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InstanceTest
{
    class Car
    {
        //フィールド==========
        private int speed;      //スピード
        private double gas;     //ガソリン情報

        //プロパティ==========
        //スピード参照用
        public int Speed
        {
            get
            {
                return this.speed;
            }
        }

        //ガソリン参照・設定用
        public double Gas
        {
            set
            {
                //止まっている場合は指定したガソリン量を給油
                if (this.speed == 0)
                {
                    this.gas += value;
                }
            }
            get
            {
                return this.gas;
            }
        }

        //コンストラクター==========
        public Car() : this(20)
        {
        }

        public Car(double gas)
        {
            this.speed = 0;
            this.gas = gas;
        }

        //メソッド==========
        //加速させるメソッド
        public virtual void SpeedUp(int sp)
        {
            //ガソリンを減らす
            this.gas -= sp / 10.0;
            if(this.gas < 0)    //ガソリンがマイナスになる場合
            {
                //ガソリンを0に補正し、スピードを増やさない
                this.gas = 0;
            }
            else
            {
                //スピードを増やす
                this.speed += sp;
            }
        }

        //減速させるメソッド
        public void SpeedDown(int sp)
        {
            //スピードを減らす
            this.speed -= sp;
            if(this.speed < 0)  //スピードがマイナスになる場合
            {
                //スピードを0に補正する
                this.speed = 0;
            }
        }
    }
}
