﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace InstanceTest
{
    class Program
    {
        //バスの状態を表示するメソッド
        static void ShowData(Bus bus)
        {
            Console.WriteLine("スピード：{0}km", bus.Speed);
            Console.WriteLine("ガソリン：{0}L", bus.Gas);
            Console.WriteLine("売上金額：{0}円", bus.SalesAmount);
            Console.WriteLine("乗車人数：{0}人", bus.PassengerNumber);
        }

        static void Main(string[] args)
        {
            //インスタンスを生成する
            Bus bus = new Bus(150);

            //現在の状態を表示する
            ShowData(bus);

            while (true)
            {
                //操作を入力
                Console.Write("1)加速　2)減速　3)給油　7)乗車　8)降車　9)終了：");
                string inputdata = Console.ReadLine();

                //操作によって分岐する
                switch (inputdata)
                {
                    case "1":
                        //加速する
                        bus.SpeedUp(5);
                        ShowData(bus);
                        break;
                    case "2":
                        //減速する
                        bus.SpeedDown(5);
                        ShowData(bus);
                        break;
                    case "3":
                        //給油する
                        bus.Gas = 80;
                        ShowData(bus);
                        break;
                    case "7":
                        //乗車する
                        string retride = bus.RideToBus(200);
                        if (retride == null)
                        {
                            ShowData(bus);
                        }
                        else
                        {
                            Console.WriteLine(retride);
                        }
                        break;
                    case "8":
                        //降車する
                        string retgetoff = bus.GetOffBus();
                        if (retgetoff == null)
                        {
                            ShowData(bus);
                        }
                        else
                        {
                            Console.WriteLine(retgetoff);
                        }                        
                        break;
                    case "9":
                        //プログラムを終了する
                        return;
                }                
            }
        }
    }
}
